/* Program  mittel.cc        */
/* By Harald Stauss          */
/* Last change 22.08. 1997   */
/* g++ -o stats stats.cc -lm */

#include <ctype.h>
#include "tsa.h"
#include "nrc/nrutil.h"
#include "nrc/nrutil.c"
#include "nrc/moment.c"

main(int argc, char *argv[]) {
  short    i;
  char     *fin, *ftin;
  char     *pfin, *pftin;
  REGIST   r;
  float    ave,adev,sdev,var,skew,curt;
  ofstream ausdat("mittel",ios::app,0);

  /*  H e l l o    w o r l d   */

  printf("MITTEL Ver. 1.1 by H. Stauss, 1997 \n");
  fin=(char *)malloc(255); pfin=fin;
  ftin=(char *)malloc(255); pftin=ftin;

  /* P a r a m e t e r   e i n l e s e n */

  if (argc != 2)
    {
      printf("Number of parameters wrong! \n");
      printf("Calculates the means of all channels \n");
      printf("Appends results to a file named >>mittel<< \n");
      printf("mittel fin \n");
      printf("fin    : name of input file (*.asc or *.tsa). \n");
      goto ende;
    }
  strcpy(fin,argv[1]);
  strcpy(ftin,fin);
  pftin=strrchr(ftin,'.');
  for (i=0; pftin[i]; i++) pftin[i]=toupper(pftin[i]);

  /* E i n g a b e d a t e i e n   o e f f n e n */
  if (strcmp(pftin,".TSA")==0) r.ReadTSA(fin);
  if (strcmp(pftin,".ASC")==0) r.ReadASCII(fin,1);
  if ((strcmp(pftin,".TSA")!=0) && (strcmp(pftin,".ASC")!=0)) {
    cout << "File type for input file not recognized! \n";
    goto ende;
  }

  /*   A u s g a b e d a t e i   p r u e f e n   */
  if (!ausdat) {
    cout << "file could not be opened for output!\n";
    goto ende;
  }

  cout << "file: " << fin << "\n";
  cout << "# \tn  \tmean \tvar \n";
  ausdat << fin << "\t";
  for (i=0; i<r.n; i++) {
    moment(r.ch[i].data-1,r.ch[i].n,&ave,&adev,&sdev,&var,&skew,&curt);
    cout << i << "\t" << r.ch[i].n << "\t" << ave << "\t" << var << "\n";
    ausdat << ave << "\t";
  }
  ausdat << "\n";
  

  ausdat.close();


 ende:
  free(fin); free(ftin);
  return 0;
} // ende des programms;
