/* Program  transpose.cc    */
/* By Harald Stauss         */
/* Last change 15.06.1998   */

#define MAX_LINE 1024

#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <fstream.h>
#include <string.h>

main(int argc, char *argv[]) {
  ifstream indat;
  ofstream outdat[100];
  int      i, j, k, rc=0, ncol, nfile;
  char     fname[256];
  char     line[MAX_LINE], iline[MAX_LINE];
  char     *cline;
  char     cd[4];

  /* Initialisierung */
  if (argc!=4) {
    cout << "Number of parameters wrong !\n";
    cout << "transpose f_in f_out n_of_files \n";
    rc=-1;
    goto ende;
  }
  strcpy(cd, "\t\n\0 ");
  nfile=atoi(argv[3]);

  /* open input file */
  indat.open(argv[1]);
  if (!indat) {
    cout << "Can't open file: " << argv[1] << "\n";
    rc=-1;
    goto ende;
  }

  /* number of columns */
  indat.getline(line, MAX_LINE);
  strcpy(iline,line);
  cline=strtok(iline,cd);
  ncol=1;
  while (cline) {
    cline=strtok(NULL, cd);
    ncol++;
  } /* endwhile */
  ncol-=2;
  cout << "number of columns: " << ncol << "\n";

  /* open output files */
  for (i=0; i<ncol; i++) {
    sprintf(fname,"%s.%d", argv[2], i+1);
    outdat[i].open(fname);
  }
  
  /* loop through input file */
  k=0;
  while(!indat.eof()) {
    strcpy(iline,line);
    cline=strtok(iline,cd);
    if (k==0) {
      for (i=0; i<ncol; i++) {
	outdat[i] << cline << "\t";
      }
    }
    j=0;
    while (cline) {
      cline=strtok(NULL, cd);
      outdat[j] << cline << "\t";
      j++;
    } /* endwhile */
    indat.getline(line, MAX_LINE);
    k++;
    if (k==nfile) {
      k=0;
      for (i=0; i<ncol; i++) {
	outdat[i] << "\n";
      }
    }    
  }


  /* close files */
  indat.close();
  for (i=0; i<ncol; i++) {
    outdat[i].close();
  }
  
ende:
  return(rc);

}
